--hidden objects--
    hiddenObj = {}

  --------------The initialization of the valid objects----------------------------

  hiddenObj.initHiddenObjects = function(gameObjectsCount, targetObjectsCount)
    math.randomseed (os.time())
    validPool = {}
    validObjects = {}
    validRemainigObjects = {}
    gameObjectsImages = {}
    objectsForGeneration = {}

    for i = 1, gameObjectsCount do
      objectsForGeneration[i] = i
    end

    howManyToRemove = gameObjectsCount - targetObjectsCount

    for i = 1, howManyToRemove do
      local randomItem = math.random (1, #objectsForGeneration)
      print ("Removing value .."..randomItem)
      table.remove (objectsForGeneration, randomItem)
    end
    validRemainigObjects = objectsForGeneration
	hiddenObj.shuffleValidObj (validRemainigObjects)
  end
  --------------------------------------------------------------------------------
  --------------------shuffling valid objects-------------------------------------
  hiddenObj.shuffleValidObj = function(validRemainigObjects)
  
  	math.randomseed (os.time())
	math.random()
	math.random()
	math.random()

	local n = #validRemainigObjects
	 
	  while n >= 2 do
		local k = math.random(n)
		validRemainigObjects[n], validRemainigObjects[k] = validRemainigObjects[k], validRemainigObjects[n]
		n = n - 1
	  end
	 
	end
 ----------------------------------------------------------------------------------
  --------------------get next object-------------------------------------------
   hiddenObj.getNextObj = function ()
		return validRemainigObjects[1]
   end
  ---------------------------------------------------------------------------------
 --------------------remove found object-------------------------------------------
   hiddenObj.removeFoundObjects = function (foundObj)
	listLenght = #validRemainigObjects
	for i=1,listLenght do
		if validRemainigObjects[i]==foundObj then
			table.remove(validRemainigObjects, i)
		end
	end
  end
  ---------------------------------------------------------------------------------
  --------------shuffle kids order-------------------------------------------------
  hiddenObj.shuffleKids = function()
	validComb = {1,1,2,2,3,3,4,4}
  	math.randomseed (os.time())
	math.random()
	math.random()
	math.random()

	local n = #validComb
	 
	  while n >= 2 do
		local k = math.random(n)
		validComb[n], validComb[k] = validComb[k], validComb[n]
		n = n - 1
	  end
	end	
	
  ---------------------------------------------------------------------------------
  --------------get new kid --------------------------------------------------
  hiddenObj.getKid = function()
	return table.remove(validComb, 1)
  end
	
  ---------------------------------------------------------------------------------
  ----------- Adding of an object's possitions to the pool for thrown objects ----

  hiddenObj.addPoint = function (x,y)
  print ("Adding the point: "..x.." "..y)
  tempPoint = {}
  tempPoint.x = x
  tempPoint.y = y
  table.insert (validPool, tempPoint)
  end
  --------------------------------------------------------------------------------

  --Get function for getting posX and posY from the pool that we added possitions-

  hiddenObj.getOneItemPossitions = function ()
  print ("Getting one item's pos from the pool...")
  whatItemIndex = math.random (1, #validPool)
  whatItem = validPool[whatItemIndex]
  for i, v in ipairs (validPool) do
    if (v.x == whatItem.x and v.y == whatItem.y) then table.remove (validPool, i)
    end
  end
  whatItemX = whatItem.x
  whatItemY = whatItem.y

  print ("The item has X: "..whatItemX.." Y: "..whatItemY)
  return whatItem.x, whatItem.y
  end

  --------------------------------------------------------------------------------

  ------------ Get function for getting a number of a valid object thrown --------

  hiddenObj.getValidObject = function ()
  
  local theValidObjectIndex = math.random (1, #validRemainigObjects)
  local tempValidObject = validRemainigObjects[theValidObjectIndex]
  table.remove (validRemainigObjects, theValidObjectIndex)
  print ("Getting one valid object from pool..."..tempValidObject)
  return tempValidObject
  end

  --------------------------------------------------------------------------------

  -------------------- Initialization of valid objects ---------------------------

  hiddenObj.generateObjects = function ()
  for i = 1, 10 do
    local randomItem = math.random (1, #objectsForGeneration)
    print ("Removing value .."..randomItem)
    table.remove (objectsForGeneration, randomItem)
  end
  end
  --------------------------------------------------------------------------------


  ---------Bool for checking valid objects----------------------------------------

  hiddenObj.isThisAValidObject = function (index)
  for i, v in ipairs (objectsForGeneration) do
    if (index == v) then print ("This item: "..index.." is valid item.") return 1
    end
  end
  print ("This item: "..index.."  is not a valid item") return 0
  end



  --- Below this line are unneded functions, keeping for refference purposes only --

    --------------------------------------------------------------------------------
  hiddenObj.getRandomPoint = function ()
  print ("Getting a random point")
  theNumberIndex = math.random (1, #pointsArray)
  return pointsArray[theNumberIndex]
  end
  --------------------------------------------------------------------------------

  hiddenObj.printSet = function (s)
  print ("Number of items in set: "..#s)
  for i, v in ipairs (s) do
    print (v)
  end
  end
  --------------------------------------------------------------------------------
  hiddenObj.getOneItemPosX = function ()
  whatItemIndex = math.random (1, #validPool)
  whatItem = validPool[whatItemIndex]
  for i, v in ipairs (validPool) do
    if (v.x == whatItem.x and v.y == whatItem.y) then table.remove (validPool, i)
    end
  end
  print ("Getting one item's X pos from the pool... "..whatItemX)
  whatItemX = whatItem.x
  whatItemY = whatItem.y
  return whatItemX
  end
  ----------------------------------------------------------------------------------
  hiddenObj.getOneItemPosY = function ()
  print ("Getting one item's Y from the pool... "..whatItemY)
  return whatItemY
  end
  -------------------code for hint randomization------------------------------------
  remainingObjects = {}
  testVar=0
  
  hiddenObj.setValidObjects = function (x)
	remainingObjects = x
	testVar = remainingObjects[1]
  end
  ----------------------------------------------------------------------------------

  ----------------------------------------------------------------------------------
  hiddenObj.randomHint = function ()
	listLenght = #remainingObjects
	math.randomseed (os.time())
	math.random()
	math.random()
	math.random()
	hintNum = remainingObjects[math.random(1,listLenght)]
	return hintNum
  end
 ------------------------------------------------------------------------------------
 --Bad dreams--
    badDreams = {}
	
 --shuffle function--
	badDreams.shuffle = function(arrayForShuffling)
  	math.randomseed (os.time())
	math.random()
	math.random()
	math.random()

	local n = #arrayForShuffling
	 
	  while n >= 2 do
		local k = math.random(n)
		arrayForShuffling[n], arrayForShuffling[k] = arrayForShuffling[k], arrayForShuffling[n]
		n = n - 1
	  end
	  return arrayForShuffling
	end	
	
	--init function--
	badDreams.initDreamSequence = function()
	
		kidsComb = {1,2,3,4}
		puzzles = {}
		
		for i = 1, 12 do
			puzzles[i] = i
		end
		
		kidsComb = badDreams.shuffle(kidsComb)
		puzzles = badDreams.shuffle(puzzles)
		
	end
	
	--get next kid--
    badDreams.getKid = function(nextKid)
		
		return kidsComb[nextKid]
    end	
	
	--get next puzzle--
    badDreams.getPuzzle = function(nextPuzzle)
     	return puzzles[nextPuzzle]
    end
------------------------------------------------------------------------------------

----------------------Invitations Sorting Randomization-----------------------------
 letters = {}

  parentArr = {"yellow", "pink", "blue", "purple"}
  --randomize the elements of the array (invoke once at the begining)
  letters.createRandomArrayPositions = function()
    math.randomseed (os.time())
    math.random()
    math.random()
    math.random()

    loadLayerOrder = 1
    for i = 1, 4 do
       j = math.random(i, 4)
       parentArr[i], parentArr[j] = parentArr[j], parentArr[i]
    end
  end

  letters.returnPositionValue = function(x)
    return parentArr[x]
  end
  
  letters.createRandomArrayPositions ()

  letters.getLayerLoadOrder = function  ()
    local loadString = parentArr[loadLayerOrder].. "LetterLayer"
    loadLayerOrder = loadLayerOrder + 1
    
    return loadString
  end

--print (letters.getLayerLoadOrder ())
--print (letters.getLayerLoadOrder ())
--print (letters.getLayerLoadOrder ())
--print (letters.getLayerLoadOrder ())


app = {}


--Rewarded Videos Flurry

app.getVideoClickCount = function()
    print("app.getVideoClickCount - trying to get videoclickCount ")
    app.incrementVideoClickCount ()
    local valueForEvent = scores:getScore("videosTried"):getValue()
        if (valueForEvent > 50) then
            valueForEvent = "50+" end
    return valueForEvent
end


app.getVideoDoneCount = function()
    print("app.getVideoDoneCount - trying to get videodoneCount ")
    app.incrementVideoWatchedCount ()
    local valueForEvent = scores:getScore("videosDone"):getValue()
        if (valueForEvent > 50) then
            valueForEvent = "50+" end
    return valueForEvent
end


app.incrementVideoClickCount = function()
    print("app.incrementVideoClickCount - trying to increase videoclickCount ")
    scores:getScore("videosTried"):increaseValue(1)
end


app.incrementVideoWatchedCount = function()
    print("app.incrementVideoWatchedCount - trying to increase videodoneCount ")
    scores:getScore("videosDone"):increaseValue(1)
end


-------android
srvc = {}

srvc.isAndroid = function()
    print("srvc.isAndroid "..tostring(isAndroid).."")
    return (isAndroid == 1)
end

------------------------------------------------------------------------------------

---------------------- Random Charcter-----------------------------

randomization = {}

math.randomseed(os.time())


function randomization.shuffleTable (t)
  local rand = math.random
  local iterations = #t
  local j

  math.random()
  math.random()
  math.random()

  for i = iterations, 2, -1 do
    j = rand(i)
    t[i], t[j] = t[j], t[i]
  end
end

function randomization.setNextCharacter (myTable)
    a = myTable[1]
    table.remove(myTable, 1)
    table.insert(myTable, #myTable+1, a)
end
function randomization.setNextCharacter2 (myTable)
    a = myTable[1]
end

function randomization.getCharacter (myTable)
  a = myTable[1]
  return a
end

function randomization.getTableValue (myTable, i)
	a = myTable[i]
	return a
end

function randomization.setNewTable (myTable, value)
   table.insert(myTable,#myTable+1,value)
end
function randomization.removeFromTable (myTable)
    table.remove(myTable, 1)
end
------------------------------------------------------------------------------------

---------------------- Random move Postion-----------------------------
opc = {}
		opc.init = function ()
		  math.randomseed(1234)
		  math.random() math.random() math.random()
		  math.random(1,1000)
		  math.random(1,1000)
		  math.random(1,1000)
		  opc.possiblePositions = {{x= 90, y = 20, userId = 0},{x= 60, y = 20, userId = 0},{x= 33, y = 20, userId = 0}}

		end

		opc.releasePosition = function (characterId)
		 for i = 1,  #opc.possiblePositions do
		  if (characterId == opc.possiblePositions[i].userId) then opc.possiblePositions[i].userId = 0 end
		 end
		end
		
		opc.emptyPosExists = function ()
		local counter = 0
		for i = 1, #opc.possiblePositions do
		if opc.possiblePositions[i].userId ~= 0 then
		counter = counter + 1
		end
		end
		if counter == #opc.possiblePositions then return 0 else return 1 end
		
		end
		

		opc.getAvailablePosition = function (characterId)
		  local pos = {}
		  pos.x = -50
		  pos.y = -50

		 for i = 1,  #opc.possiblePositions do
		  if (characterId == opc.possiblePositions[i].userId) then
			 pos.x= opc.possiblePositions[i].x
			 pos.y= opc.possiblePositions[i].y
			 return pos
			end
		 end
		 --TODO: avoid getting stuck inside while / rework if needed
		 local loopCount = 0
		while (true) do
		 loopCount = loopCount + 1
		 local i = math.random(1,#opc.possiblePositions)
		   if (opc.possiblePositions[i].userId == 0) then
			pos.x= opc.possiblePositions[i].x
			pos.y= opc.possiblePositions[i].y
			opc.possiblePositions[i].userId = characterId
			return pos
		   end
		   if (loopCount > 10000) then return pos end
		   end
		   --services:debugMessageBox("bug","Available position for new customer not found!!! Debug inside customerController!!!")
		end
